'woodstove.bas  5/11/07
'clk on 7, dta/dq on 6
'shared outdoor temp reset with pin close limit switch.
'stored high and low temp limits in eeprom and reset them to base values if eeprom is corrupted
'NOTE stepper count and exhaust damper degrees rotated are not exactly equal.
' they are not a 1 to 1 relationship because the linkage is not matched to degrees rotation at full travel limits.
' stepper rotation is more than travel of exhaust damper at full travel due to linkage angles
'NOTE KRONOS SERIAL COMMANDS USE INVERTED MODE, SEETRONS USE NON-INVERTED MODE.
'NOTE pin 14 on my ATOM is bad. Code does not use this pin. This is the reason for some illogical pin groupings
'NOTE ------------------------------------------------
'NOTE THIS CODE ONLY WORKS ON THE ATOM
'------------------------------------------------
' ATOM SHIFTIN AND OUT IS DIFFERENT THEN PARALLAX STAMP
'n9600 con $4054	'lcd display
'ds1620 code from ATOM WEBSITE
'ds1620 constants below
'
'---------------CONSTANTS------------------

dq con 6 ' DATA ds1620 shared by 2 temp sensors and one clock
clk con 7
indoorRST con 9 'reset indoor ds1620 thermometer
OutdoorRST con 4 'reset outdoor ds1620 thermometer shared with closed limit switch
rtcreset CON 8 'reset ds1302 clock
thdta con 10 'MAX6675 pin used to read data
thcs con 11 ' MAX6675 pin to send CS/Reset signal
thclk con 12 'MAX6675 pin to send clock signals
rconfig con $AC ' read configuration
wconf con $0C ' write configuration
cpu con %10  ' config bit serial thermometer mode
cpucon con $02
nocpu con %00 ' config bit standalone thermostat mode
oneshot con %01 ' config bit opne conversion per start request
cont con %00 'config bit continuous conversions after start
startc con $EE ' protocal for start conversion
stopc con $22 'protocal for stop conversion
Rtemp con $AA ' protocal for read temperature
RHit con $A1 'protocal for read high temperature setting
Whit con $01 'protocl for write high temp setting
RLot con $A2 'read low temp setting
WLot con $02 'write low temp setting
'ds1620 constants above
secreg con %00000 'ds1302 clock
minreg con %00001 'ds1302 clock
hrsreg con %00010 'ds1302 clock
datereg con %00011 'ds1302 clock
monreg con %00100 'ds1302 clock
yrreg con %00110 'ds1302 clock
CtrlReg con %00111 'ds1302 clock
BrstReg con %11111 'ds1302 clock
tric con %1001000 ' trickle charge register I guess
OFFtric CON %11110000  ' TRICKLE CHARGER TURNED OFF
DIR1 CON %10100101 ' 1 diode 1 resistor  charge rate. see Dallas data sheet
'
'-----------------VARIABLES---------------------------------
'
i var byte ' general purpose variable
x var byte ' Used in Raise and lowerTempLimit subroutines
DailyLowHour var byte ' storage for outside temperature time in EEprom
DailyLowMinute var byte ' storage for outside temperature time in EEprom
DailyHighHour var byte ' storage for outside temperature time in EEprom
DailyHighMInute var byte ' storage for outside temperature time in EEprom
YearlyLowMonth var byte 'Storage for outside temperature date in EEprom
YearlyLowDay var byte 'Storage for outside temperature date in EEprom
YearlyHighMonth var byte 'Storage for outside temperature date in EEprom
YearlyHighDay var byte 'Storage for outside temperature date in EEprom
' note year is not saved because it should be known what year we are working in!
DailyLowTemp var sword  ' eeprom location 10 stored
DailyLowSIgn var byte '  eeprom location 22 stored
DailyHighTemp var sword ' eeprom location 12 stored
YearlyLowTemp var sword  'eeprom location 11 stored
YearlyLowSign var byte 'Eeprom Location 23 stored
YearlyHighTemp var sword 'eeprom location 13 stored
result var word ' max6675 shiftin variable
temperature var word ' max6675
tempcorrection var word 'used to calibrate the fire temperature max6675
fire var byte	'how many times the fire has been lit. Runtime variable
min var word ' Used for Burntime
HoursCounter var byte ' Used for Burntime
DaysCounter var byte ' Used for Burntime
tempold var word	' to store old temperature for comparison each 10 seconds
TempOldMinute 	var word	' to store temperature each minute
exhaustopenlimitbit var bit 	' used to indicate when exhaust is wide open
exhaustclosedlimitbit var byte
exhaustmovedclosedbit var byte
exhaustmovedopenbit var byte
Exhaustclosequantity var word ' used to determine how much to close damper based on temperature heating speed
hightemp var byte ' use byte for writing to memory
lowtemp var byte
DSdata var word 'to hold 9 bit register
Sign var bit 'sign bit of raw temperature
IndoorTemperature var word  ' for ds1620 inside temp
OutdoorTemperature var sword  ' for ds1620 Outdoor temp
InCentigrade	Var		Long	;Floating point C temp
InFahrenheit	Var		Long	;Floating point F temp
NegTemp			var		byte  ' NOTE this is critical. I use a byte to limit binary digits to 8
tempC			var		sword
tempEeprom		var		byte	' used for eventual storage into eeprom 0-255 values only allowed in eeprom
firebit var bit
AttemptsHigh var byte 'used for tempcheck routines
AttemptsLow var byte ' used for tempcheck routines
stepcount var byte
'-------ds1302 clock variables
rtccmd var byte 'ds1302 clock
temp var byte   'ds1302 clock
seconds var byte   'ds1302 clock
minutes var byte   'ds1302 clock
hours var byte   'ds1302 clock
date var byte   'ds1302 clock
day var byte    'ds1302 clock
month var byte   'ds1302 clock
year var byte   'ds1302 clock
control var byte  'ds1302  clock
bcd var byte ' used for decimal to bcd conversion
'convert decimal to BCD binary code decimal format
BCDMinutesVal var byte  ' used for burntime
BCDHoursVal var byte ' used for burntime
BurntimeBit var bit
TempCheckCounter var word   ' temporary test
ClockChange var byte	' to see if clock seconds digit has changed or not
clockchange = 7		' to see if clock seconds digit has changed or not
TempCheckCounter = 0	'temporary test variable
exhaustopenlimitbit = 0		' exhaust fully open bit
Exhaustclosequantity = 0
exhaustclosedlimitbit = 0
exhaustmovedopenbit = 0
exhaustmovedclosedbit = 0
tempcorrection = 1	'no real correction needed on my system. Left in for future needs
hightemp = 200
lowtemp = 150
AttemptsHigh = 0 ' used for firetemp over time check
AttemptsLow = 0 ' used for swapping state of trys bit in a loop
min = 0 ' for burntime counter
HoursCounter = 0 'for burntime counter
Dayscounter = 0 'for burntime counter
BurntimeBit = 0 ' for burntime counter
firebit = 0 ' used for fire out and lit subroutines

'----------------------------------------------SETUP CODE BELOW--------------------------------
gosub cleardisplay
	serout 1,i9600,[1,1,"START"] ' line1, starting from home
	pause 2000
gosub readrtcburst
gosub tempreading
	tempold = temperature ' this does nothing, tempreading sends control to tempcheck first
gosub exhaustcount
	exhaustopenlimitbit = 0 ' vent has moved during setup, set this bit back to zero for normal program execution
'	gosub programClockTime ' PROGRAM CLOCK DATE AND YEAR USING SEPERATE STAND ALONE PROGRAM
gosub ds1620Indoorsetup
gosub ds1620OutdoorSetup
gosub tempoutdoor	
	' PROGRAM CLOCK TO START run this to prevent clock locking up if a reset occurs.
	temp =$10
	RTCCmd = ctrlreg
gosub writertc
	temp = $00
	rtccmd = secreg
gosub writertc
	temp=dir1
	rtccmd = tric
gosub trick
	temp = $80
	rtccmd = ctrlreg
gosub writertc

'======================================================MAIN=============================================================	
'
'
'======================================================MAIN=============================================================
'
'		
MAIN 
	'NOTE tempoutdoor read evey ten minutes in UpdateOutsideTemp  subroutine.
	GOSUB INCTIME
	Gosub TempIndoor
	gosub exhausttempdisplay
	if in5  = 1 then gosub exhaustwideopen ' limit switch
	if in4 = 1 then gosub exhaustfullyclosed 'limit switch
	if in0 = 1 then gosub fires
	if in13 = 1 and in0 = 1 then gosub increaseminutes
	if in15 = 1 and in0 = 1 then gosub INCREASEHOURS  
	if in13 = 1 then gosub raisetemplimit
	if in15 = 1 then gosub lowertemplimit
	if temperature <= 99 then gosub FireOut
goto main

'======================================LCD DISPLAY SUBROUTINES================================
'
'
'======================================LCD DISPLAY SUBROUTINES================================
'
'
EXHAUSTTEMPDISPLAY ' on 1st line------------------------------------EXHAUSTTEMPDISPLAY-------------------
	'NOTE the highnib is the lefthand digit of the clock display. Lownib is the righthand digit.
	' ten lownibs will pass before one highnib will increment. Analagous to a cars odometer
	serout 1,i9600,[1,1,"IN ",dec indoortemperature," OUT "] ' 10
	 digits
	serout 1,i9600,[1,11, sdec outdoortemperature]
	serout 1,i9600,[1,13," FIRE ",dec temperature,"    "]
	serout 1,i9600,[2,1,dec hours.highnib,dec hours.lownib,":",dec minutes.highnib,dec minutes.lownib,":",|
	dec seconds.highnib,dec seconds.lownib," ",dec month.highnib,dec month.lownib,"/",dec date.highnib,|
	dec date.lownib,"/" ,dec year.highnib, dec year.lownib," "]
	serout 1,i9600,[2,19," V "]
	serout 1,i9600,[2,22,dec stepcount]
return


FIRES ' subroutine to display how many times the fire has been lit
	'read in all the values from eeprom. NOTE these are in decimal format and can be displayed as such.
	'while program is running they are stored in RAM variable. If power is shut down this will get them back from
	'EEPROM to be displayed properly
	gosub readEEPROM
	dailylowtemp   = dailylowtemp   - 100	' convert back to a signed variable for display
	YearlyLowTemp  = YearlyLowTemp  - 100
	dailyhightemp  = dailyhightemp  - 100
	yearlyHighTemp = yearlyHighTemp - 100
	SEROUT 1,I9600,[1,23,"  "] ' CLEAR THE DISPLAY positions 23 and 24
	SEROUT 1,I9600,[2,23,"  "]  'CLEAR THE DISPLAY 
	pause 1 ' in case another subroutine left extraneous character here
	'NOTE the following display uses Decimal format variables as opposed to clock displays that use BCD format
	serout 1,i9600,[1,1,"Day L "] '1-6
	serout 1,i9600,[1,7,sdec dailylowtemp," ",dec DailylowHour,":",dec DailylowMinute," ",| ' | linebreak
	"H ",sdec dailyhightemp," ",dec DailyHighHour,":",dec dailyHighMinute]
	serout 1,i9600,[2,1,"YR.","L "]
	serout 1,i9600,[2,6,sdec yearlylowtemp," ",dec yearlylowmonth,"/",dec yearlylowday," ",| '| linebreak
	"H ",sdec yearlyHighTemp," ",dec yearlyHighMonth,"/",dec YearlyHighDay]
	pause 1000
return


BURNTIME 'on 2nd line------------------------------------- BURNTIME-----------------------
	READ 7,FIRE
	bcdMinutesVal = (min /10) <<4 + (min // 10)
	bcdHoursVal = (hourscounter /10) <<4 + (hourscounter // 10) ' Convert the values to bcd to get proper digit placements
	'Display has already been cleared in up and down subroutines
	serout 1,i9600,[2,1,"Burn ",dec dayscounter,"; "] ' 1-9 display positions
	serout 1,i9600,[2,9, dec bcdhoursVal.highnib,dec BCDhoursVal.lownib,":",dec BCDminutesVal.highnib,|
	dec BCDminutesVal.lownib," "] '10-15
	serout 1,i9600,[2,22,"  "] ' clear the display for fire number position
	pause 1
	SEROUT 1,I9600,[2,16,"Fires ", dec fire," "] ' 16-24 DISPLAY POSITIONS
return

FIREOUT 
 	serout 1,i9600,[2,24,"!"]
 	firebit = 0
	min = 0 ' Reset burntime counters
	HoursCounter = 0 ' Reset burntime counters
	DaysCounter = 0 ' Reset burntime counters
return


STABLE ' fire temp is in between upper and lower limits
	if temperature = tempold then
	goto StableBypass
	endif
	if (tempOld - temperature) >=3  then 'temp has cooled 3 degrees in 10 seconds so open damper
	gosub exhaustopen ' keep temp in stable range if possible
	endif
	if (tempOldMinute - temperature) >=6  then 'temp has cooled 6 degrees in 60 seconds so open damper
	gosub exhaustopen ' keep temp in stable range if possible
	endif
	if (temperature - tempold) >=3  then ' temp has risen 3 degrees in 10 seconds so close damper
	gosub exhaustclosed ' keep temp in stable range if possible
	endif
	if (temperature - tempoldminute) >=6  then ' temp has risen 6 degrees in 60 seconds so close damper
	gosub exhaustclosed ' keep temp in stable range if possible
	endif
	exhaustopenlimitbit = 0
StableBypass
	serout 1,i9600,[1,24,"-"]
	serout 1,i9600,[2,24,"-"]
	pause 100
return

CLEARDISPLAY
	SEROUT 1,I9600,[1,1,"                        "] ' CLEAR THE DISPLAY
	SEROUT 1,I9600,[2,1,"                        "]  'CLEAR THE DISPLAY
return


'=========================================EXHAUST DAMPER CONTROL ROUTINES==========================
'
'
'=========================================EXHAUST DAMPER CONTROL ROUTINES==========================
'
'

EXHAUSTOPEN ' on 2nd line-------------------------------EXHAUSTOPEN----------------------------
	stepcount = stepcount + 2 'Stepper only moves one step, but add two for display purposes
	exhaustmovedopenbit = 1
	exhaustmovedclosedbit = 0
	gosub cleardisplay
	serout 1,i9600,[1,1,"Exhaust Opening  ", dec stepcount]
	serout 1,i9600,[1,20,"O"]
	serout 1,i9600,[2,1,"New Temp ",dec temperature," Old ",dec tempold,"    "]
	serout 1,i9600,[2,24,"O"]
	low p2   ' this determines stepper rotation
	pulsout p3,25000  '25 milliseconds
	pause 500
OpenBypass
return


EXHAUSTCLOSED ' on 2nd line--------------------------EXHAUSTCLOSED-----------------------------
	stepcount = stepcount - 2 ' stepper moves ONLY 1 step, but I subtract 2 for display reasons
	exhaustmovedclosedbit = 1
	gosub cleardisplay
	serout 1,i9600,[1,1,"Exhaust Closing  ", dec stepcount]
	serout 1,i9600,[1,20,"C"]
	serout 1,i9600,[2,1,"New Temp ",dec temperature," Old ",dec TEMPOLD,"   "]
	serout 1,i9600,[2,24,"C"]
	high p2  ' this determines stepper rotation
	pulsout p3,25000
	pause 500
ClosedBypass
return

EXHAUSTWIDEOPEN
	exhaustopenlimitbit = 1		'to prevent exhaust constantly trying to open when temp is low
	stepcount = 90
gosub cleardisplay
	serout 1,i9600,[1,1,"OPEN LIMIT"]
	pause 2000
	for i = 1 to 4  ' how far to back off limit switch when full travel
	gosub exhaustclosed
	next 
	serout 1,i9600,[1,24,"L"]
	serout 1,i9600,[2,24,"L"]
'	stepcount = 82 ' stepper has been backed off 4 steps by subroutine and multiply *2 for display purposes
RETURN

EXHAUSTFULLYCLOSED
	exhaustclosedlimitbit = 1
	gosub cleardisplay
	serout 1,i9600,[1,1,"CLOSE LIMIT"]
	pause 2000
	for i = 1 to 4  ' how far to back off limit switch when full travel
	gosub exhaustopen
	next 
	serout 1,i9600,[1,24,"L"]
	serout 1,i9600,[2,24,"L"]
	stepcount = 8 ' stepper has moved 4 positions off from limit switch. Multiply * 2 for display
	low 4	'prevent loop because of shared pin with outside temp
RETURN

	
EXHAUSTTOHOT ' go here if temp is high and damper was fully open
	exhaustopenlimitbit = 0
	for i = 1 to 20 ' close damper 20 steps and show on display stepcount * 2 for display reasons
	gosub exhaustclosed
	next
return


FIRELIT
	gosub exhauststepcountreset  'reset the vent to wide open and the stepcount to 82
	firebit = 1
	read 7, fire
	fire = fire + 1
	write 7, fire
	exhaustopenlimitbit = 0
return



COOLINGFAST ' temp is falling to faST OPEN damper 2 steps each time.
	for i = 1 to 2
	gosub exhaustopen
	next
return

HEATINGFAST 'temp is climbing to fast close damper based upon how fast it is heating.
	attemptsHigh = 0 '40 seconds have passed, so reset the attemptsHigh counter
	if exhaustclosequantity >=4 then  
	exhaustclosequantity = 4
	endif
	attemptshigh = 0 
	FOR I = 0 to Exhaustclosequantity
	gosub exhaustclosed
	next
return	


'============================================TEMPERATURE SUBROUTINES==============================================
'
'
'============================================TEMPERATURE SUBROUTINES==============================================
'
'The following subroutines all pertain to temperature measurement and calculations
'
'
TEMPREADING ' max6675  BASICMICRO ATOM Code only!-----------------------------------
' The max6675 does not require any setup routines to operate.
	low thcs 'must set CS low
	shiftin thdta,thclk,msbpre,[result\16] ' get data;will set thclk high then low 16 times
	high thcs ' start new data capture
	temperature=result>>5 ' shift data 5 bits to the right
	temperature = temperature */117965 ' multiply times 1.8 to convert to farenheit
	temperature = temperature + 32 ' add 32 to finalize conversion
	temperature = temperature + tempcorrection ' TO CALIBRATE THE SENSOR
	exhaustMovedOpenBit = 0 ' every ten seconds we come to this loop so only allow damper to move every ten seconds
	exhaustmovedclosedBit = 0
	gosub tempcheck
RETURN


TEMPCHECK '----------------------------TEMPCHECK--------------------
	TempCheckCounter = TempCheckCounter + 1
	AttemptsLow = AttemptsLow + 1
	if attemptslow >6 then
	attemptslow = 0
	endif
	attemptsHigh = AttemptsHigh + 1
	
	if attemptsHigh >6 then
	attemptsHigh = 0
	endif
	
	if temperature >= 100 AND FIREBIT = 0 then gosub FIRElit	'fire has been started
	
	if temperature <= 99 then 'fire must be out or almost out
	goto bypass
	endif
	
	if temperature <= lowtemp and temperature > tempold then
	goto bypass
	endif
	'temperature is rising on it's own, leave it alone
	
	if temperature >= hightemp and temperature <= tempold then
	goto bypass
	endif
	'temp is falling so leave the damper alone
	
	if temperature >=lowtemp and temperature <=hightemp then gosub stable
	
	if temperature <= lowtemp and in5 = 0 then gosub templowcheck '150
	
	if temperature >= hightemp and in4 = 0  then gosub temphighcheck   '200
	bypass
return

TEMPLOWCHECK   '150
	If exhaustopenlimitbit = 1 then skip	'exhaust damper is wide open already so SKIP
	
	if temperature < lowtemp and exhaustmovedopenbit = 0 then gosub exhaustopen
	'do the above, we know it is less then lowtemp already, so do this every ten seconds
	
	if temperature = tempold and temperature < lowtemp and AttemptsLow >= 6 and exhaustmovedopenbit = 0 then 
	AttemptsLow = 0
	gosub exhaustopen
	endif
	' do the above if temp is below lowtemp and has not changed for one minute.
	SKIP
return

	

TEMPHIGHCHECK    '200' remember this subroutine runs every 10 seconds.
	if exhaustopenlimitbit = 1 then gosub exhausttohot	'temp is above limit and damper is wide open
	' close damper 20 steps to get it within midrange
	
	if temperature = tempold and AttemptsHigh >=6 and in4 = 0 then
	attemptsHigh = 0
	gosub exhaustclosed
	endif
	'holding steady but over limit, temperature is over hightemp or we would not be in this subroutine, if temp is stable, but still above hightemp
	'and 1 minute has passed then go to exhaustclosed
	
	if temperature > tempold  and attemptsHigh >=4 then '4 times in this subroutine, so check at 40 seconds
	Exhaustclosequantity = temperature - tempold 
	gosub heatingfast
	endif
return


TEMPINDOOR 'atom code
	low CLK
	high IndoorRST   ; start 1620 ATOM PIN 9
	shiftout dq,CLK,LSBPRE,[Rtemp\8] ; Request 
	
	shiftin dq,CLK,LSBPRE,[Indoortemperature\9]  ; Get temperature
	low IndoorRST
'	Sign = Indoortemperature.bit8 ' inside never gets below 32 degrees.
	Indoortemperature = Indoortemperature & $ff
	Indoortemperature = Indoortemperature/2
	Indoortemperature = Indoortemperature */117965 ' this is a conversion times 1.8 so you do not need floating point math
	' ;to calculate the fraction .05 for use with the following MULM(*/) function use
'     this formula. fraction = 1.8 * 65536 = 117964.8 round off too 117965
	Indoortemperature = Indoortemperature + 32
return

TEMPOUTDOOR 'atom code
	low CLK
	high OutdoorRST   ; start 1620 ATOM PIN 6
	shiftout dq,CLK,LSBPRE,[Rtemp\8] ; Request 
	shiftin dq,CLK,LSBPRE,[dsdata\9]  ; Get temperature
	low OutdoorRST
	Sign = dsdata.bit8
	if sign = 1 then gosub negativeTemp
	if sign = 0 then gosub PositiveTemp
		
return



PositiveTemp
	dsdata = dsdata & $ff
	OutDoorTemperature = dsdata / 2
	'Fahrenheit code below
	OutDoorTemperature = OutDoorTemperature */117965
	OutDoorTemperature = OutDoorTemperature + 32
	if OutDoorTemperature < = 32 then
	OutDoorTemperature = 32 	' sometimes would show -196 on transition, set to 32 just in case
	gosub negativeTemp  
	endif
return

NegativeTemp
	NegTemp = 0
	'DSdata  =  %111011010 		'13 degree
	NegTemp =%111111111- dsdata 'NegTemp assigned a byte variable to only hold 8 digits this was done deliberatly
	INCentigrade = Float NegTemp fmul 0.5 ' this is a bassackwards way of dividing by 2
	NegTemp = int Incentigrade
	' Fahrenheit code below
	InFahrenheit = fneg InCentigrade ' get it into negative number
	tempc = int InFahrenheit
	OutDoorTemperature = tempc * 18  ' could not multiply a negative number times 1.8 so do * 18 /10 instead
	OutDoorTemperature = OutDoorTemperature / 10
	OutDoorTemperature = OutDoorTemperature + 32
'	OutDoorTemperature = OutDoorTemperature - 5 ' temperature correction factor IF NEEDED
return


UPDATEOUTSIDETEMP ' LOWEST OUTDOOR TEMP STORAGE
	Gosub TempOutdoor  ' read outside temp every ten minutes
	tempEEprom = OutdoorTemperature + 100 	' add 100 to get rid of negative numbers
	'DailyLowTemp
	gosub readEEprom
	if tempeeprom < DailyLowTemp then
	write 10, tempEEprom ' write the outdoor temperature into the eeprom location
	dailyLowtemp = tempEEprom ' save the new lowest temp in working RAM memory
	dailylowhour = (hours.nib1 * 10) + hours.nib0 'convert BCD to decimal	
	dailylowminute = ( minutes.nib1 * 10) + minutes.nib0
	write 14, DailyLowHour
	write 15, DailyLowMinute
	write 22, sign  ' sign of temperature + or -	
	'YearlyLowTemp
	elseif tempEEprom < YearlyLowTemp 
	write 11, tempEEprom
	write 23,SIgn ' Sign of temperature + or -
	yearlylowtemp = tempEEprom
	yearlylowmonth =(month.nib1 * 10) + month.nib0
	YearlyLowDay =( date.nib1 * 10) + date.nib0
	write 18, yearlylowmonth
	write 19, yearlylowday
	'DailyHighTemp
	elseif tempEEprom > dailyHighTemp 
	write 12, tempEEprom
	dailyhightemp = tempEEprom
	DailyHighHour = (hours.nib1 * 10) + hours.nib0 'convert BCD to decimal
	DailyHighMinute = ( minutes.nib1 * 10) + minutes.nib0
	write 16, dailyhighhour
	write 17, dailyhighminute
	'YearlyHighTemp
	elseif tempEEprom > YearlyHighTemp
	write 13,tempEEprom
	yearlyhightemp = tempEEprom
	YearlyHighMonth = (month.nib1 * 10) + month.nib0
	YearlyHighDay = ( date.nib1 * 10) + date.nib0
	write 20, YearlyHighMonth
	write 21, yearlyHighDay
	endif
return

RESETDAILYTEMPERATURE 'once a day RESET THE HIGH AND LOW TEMPS
	dailylowtemp = tempEEprom
	dailyhightemp = tempEEprom
	write 10,tempEEprom
	write 12,tempEEprom
return


'===============================MANUAL SWITCH CONTROL SUBROUTINES=====================================================
'
'
'===============================MANUAL SWITCH CONTROL SUBROUTINES=====================================================
'
'

RAISETEMPLIMIT'---------------------------------RAISETEMPLIMIT-----------------------
	gosub cleardisplay
	FOR x = 1 to 50 ;loop while switch is pressed, until count reaches 50 OR HIGHER
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	PAUSE 30 
	IF IN13 = 0 THEN ; A low ("0") indicates that switch is released before loop's end
	GOTO EARLYSWITCH13RELEASE ; If switch released before loop's end, go to subroutine
	x = 51 ; come back here from subroutine. Increases loop count and ensures loop ends at NEXT
	ENDIF
	NEXT
	' about a full 3 second switch press
	IF x = 50 THEN
'	3 seconds ACHIEVED
	ENDIF
RAISEAGAIN	
	HIGHTEMP = HIGHTEMP + 1
	lowtemp = lowtemp + 1
	gosub cleardisplay
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	pause 1000
	write 8,lowtemp
	write 9,hightemp
	IF IN13 = 1 THEN GOTO RAISEAGAIN
return


EARLYSWITCH13RELEASE
	gosub cleardisplay
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	pause 1000
GOTO MAIN


LOWERTEMPLIMIT
	gosub cleardisplay
	FOR x = 1 to 50 ;loop while switch is pressed, until count reaches 50 OR HIGHER
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	PAUSE 30 
	IF IN15 = 0 THEN ; A low ("0") indicates that switch is released before loop's end
	GOTO EARLYSWITCH15RELEASE ; If switch released before loop's end, go to subroutine
	x = 51 ; come back here from subroutine. Increases loop count and ensures loop ends at NEXT
	ENDIF
	NEXT
	;Aabout a full 3 second switch press
	IF x = 50 THEN
'	3 seconds ACHIEVED
	ENDIF
RAISE15AGAIN	
	LOWTEMP = LOWTEMP - 1
	hightemp = hightemp - 1
	gosub cleardisplay
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	PAUSE 1000
	write 8,lowtemp
	write 9,hightemp
	IF IN15 = 1 THEN GOTO RAISE15AGAIN
return


EARLYSWITCH15RELEASE
	gosub cleardisplay
	pause 1
	serout 1,i9600,[1,1,"LOWTEMP ", dec lowtemp]
	serout 1,i9600,[1,12," HighTemp ",dec hightemp," "] 'note space in front of hightemp
	gosub burntime
	pause 1000
GOTO MAIN



INCREASEMINUTES ' Used for manually adjusting clock time only
	SEROUT 1,I9600,[1,1,"    ADJUST TIME         "] ' CLEAR THE DISPLAY
	serout 1,i9600,[2,1,dec hours.highnib,dec hours.lownib,":",dec minutes.highnib,dec minutes.lownib,":",dec seconds.highnib,dec seconds.lownib," ",dec month.highnib,dec month.lownib,"/",dec date.highnib,dec date.lownib,"/" ,dec year.highnib, dec year.lownib," "]
	PAUSE 1000
	minutes = 0 'start from 0 to make things neater and more understandable
increaseminutesagain
	MINUTES=MINUTES + 1
	if minutes > 60 then
	minutes = 0
	endif
	SEROUT 1,I9600,[1,1,"    ADJUST TIME         "] 
	serout 1,i9600,[2,1,dec hours.highnib,dec hours.lownib,":",dec minutes,":",dec seconds.highnib,dec seconds.lownib," ",dec month.highnib,dec month.lownib,"/",dec date.highnib,dec date.lownib,"/" ,dec year.highnib, dec year.lownib," "]
	'NOTE this is just a variable so far, it has to be written into high and low nibs inside the clock chip 	 
	PAUSE 500  ' DELAY SO CHANGE IS NOT SO FAST
	if in13 = 1 and in0 = 1 then 'button's are still pushed so increment minutes once again
	goto increaseminutesagain
	endif
	bcd = (minutes/10) <<4 + (minutes //10) 'convert decimal to BCD binary code decimal format
		
	temp =$10
	RTCCmd = ctrlreg
	gosub writertc
	
	temp = bcd ' MINUTES
	rtccmd = minreg
	gosub writertc
	
	temp = $00
	rtccmd = secreg
	gosub writertc
	
	temp = $80
	rtccmd = ctrlreg
	gosub writertc
	
	gosub ReadRTCBurst
	
RETURN
 
 
 INCREASEHOURS ' Used for manually setting the clock
 	SEROUT 1,I9600,[1,1,"    ADJUST TIME         "] ' CLEAR THE DISPLAY
	Serout 1,i9600,[2,1,dec hours.highnib,dec hours.lownib,":",dec minutes.highnib,dec minutes.lownib,":",|
	dec seconds.highnib,dec seconds.lownib," ",dec month.highnib,dec month.lownib,"/",dec date.highnib,dec date.lownib,|
	"/" ,dec year.highnib, dec year.lownib," "]
	PAUSE 500
	hours = 0 'start from 0 to make things neater and more understandable
	increasehoursagain
	hours = hours + 1
	if hours > 23 then ' 24 hour format
	hours = 0
	endif
	SEROUT 1,I9600,[1,1,"    ADJUST TIME         "] ' CLEAR THE DISPLAY 
	serout 1,i9600,[2,1,dec hours,":",dec minutes.highnib,dec minutes.lownib,":",|
	dec seconds.highnib,dec seconds.lownib," ",dec month.highnib,dec month.lownib,"/",dec date.highnib,dec date.lownib,|
	"/" ,dec year.highnib, dec year.lownib," "]
	'NOTE HOURS is just a variable so far, it has to be written into high and low nibs inside the clock chip 	 
	PAUSE 500  ' DELAY SO CHANGE IS NOT SO FAST
	if in15 = 1 and in0 = 1 then 'button's are still pushed so increment HOURS once again
	goto increaseHoursagain
	endif
	bcd = (hours/10) <<4 + (hours//10) 'convert decimal to BCD binary code decimal format
	
	temp =$10
	RTCCmd = ctrlreg
	gosub writertc
	
	temp = bcd  ' HOURS   
	rtccmd = hrsreg
	gosub writertc
	
	temp = $00 'seconds
	rtccmd = secreg
	gosub writertc
	
	gosub ReadRTCBurst
	temp = $80
	rtccmd = ctrlreg
	gosub writertc
 RETURN

'============================================= CLOCK DS1302 SUBROUTINES ===============================================
'
'============================================= CLOCK DS1302 SUBROUTINES ===============================================

'The following subroutines all pertain to clock or timing routines.


INCTIME '---------------------------------------------INCTIME
	'Read the left nib of seconds variable and make decisions upon it. this is the left digit of a clock display
	gosub ReadRTCBurst  'ds1302 clock 
	if seconds.lownib = clockchange.lownib then bypassinctime
	if seconds.highnib =  0 and seconds.lownib = 0 then gosub ChangeBurntimeBit '00 seconds
	if seconds.highnib =  1 and seconds.lownib = 0 then gosub tempoldsave '10 seconds
	if seconds.highnib =  2 and seconds.lownib = 0 then gosub tempreading '20 seconds
	if seconds.highnib =  3 and seconds.lownib = 0 then gosub tempoldsave
	if seconds.highnib =  4 and seconds.lownib = 0 then gosub tempreading
	if seconds.highnib =  5 and seconds.lownib = 0 and burntimebit = 0 then gosub incTrys  'TEMPOLDSAVE
	'--------------MINUTES--------------
	if minutes.highnib = 5 and minutes.lownib = 0 then gosub updateoutsidetemp '50 minutes
	if minutes.highnib = 4 and minutes.lownib = 0 then gosub updateoutsidetemp '40 minutes
	if minutes.highnib = 3 and minutes.lownib = 0 then gosub updateoutsidetemp '30 minutes
	if minutes.highnib = 2 and minutes.lownib = 0 then gosub updateoutsidetemp
	if minutes.highnib = 1 and minutes.lownib = 0 then gosub updateoutsidetemp
	if minutes.highnib = 0 and minutes.lownib = 0 then gosub updateoutsidetemp
	' minutes ' note the highnib is the lefthand digit of clock displays. this will updateoutsidetemp every ten minutes
	'note ten minutes passes before each highnib is updated
	'look at a digital clock and see how the lefthand counter digits move. the righthand lownib digit moves ten times
	' for every one movement of the highnib, analagous to a car's odometer
	'--------------------HOURS------------------
	if hours.highnib = 0 and hours.lownib = 0 then gosub resetdailytemperature ' this is 00 "AM" in 24 hr format
	clockchange = seconds.lownib
bypassIncTime
return


ChangeBurntimeBit
	TempOldMinute = temperature		' every minute save the Old temperature	
	burntimebit = 0
	gosub tempreading
return


TEMPOLDSAVE ' every ten seconds save old temperature of fire
	gosub tempreading
	tempold = temperature
return

INCTRYS 
		gosub  tempoldsave ' came here once because seconds.highnib is a 5
	if	firebit = 1 then gosub increaseburntimeMinutes
return 

IncreaseBurntimeMinutes
	min = min + 1
	if min >=59 then gosub IncreaseBurntimeHours
	Burntimebit = 1
return

IncreaseBurntimeHours
	min = 0
	if hourscounter >=24 then gosub IncreaseBurntimeDays
	hourscounter = hourscounter + 1
return

IncreaseBurntimeDays
	hourscounter = 0
	Dayscounter = DaysCounter + 1
return




TRICK
	high rtcreset
	shiftout dq,clk,lsbfirst,[rtccmd,temp]
	low rtcreset
return	

writertc
	high RTCReset
	shiftout dq,clk,lsbfirst,[%0\1,rtccmd\5,%10\2,temp]
	low RTCReset
return

readrtcBurst
	high rtcreset
	shiftout dq,clk,lsbfirst,[%1\1,brstreg\5,%10\2]
	shiftin dq,clk,LSBPRE,[seconds\8,minutes\8,hours\8,date\8,month\8,day\8,year\8,control\8]
	low RTCReset
Return

 ReadEEprom
 	read 7,fire
	read 8,lowtemp 
	read 9, hightemp
	read 10,dailylowtemp
	read 11,yearlylowtemp
	read 12,dailyHighTemp
	read 13,Yearlyhightemp
	read 14,dailylowhour
	read 15,dailylowminute
	read 16,dailyhighhour
	read 17,dailyHighMinute
	read 18, YearlyLowMonth
	read 19,YearlyLowDay
	read 20,YearlyHighMonth
	read 21,YearlyHighDay
	read 22, DailyLowSign
	read 23, YearlyLowSign
  return


'===========================================SETUP ROUTINES===============================================


'===========================================SETUP ROUTINES===============================================
'
' the following routines are used only once on initial program, some may not be used at all depending on state of
' EEPROM

EXHAUSTCOUNT  ' RUN once here to get proper stepper motor count number
	exhaustopenlimitbit = 0
	Gosub ReadEEprom
	if fire = 255 or fire < 1 then gosub settemplimits	
	if lowtemp = 0 or hightemp = 0 then gosub settemplimits ' eeprom values were bad, reset them to base limits
	if lowtemp =255 or hightemp = 255 then gosub settemplimits
	if lowtemp < 50 or hightemp < 140 then gosub settempLimits
	if dailylowtemp < 1 or yearlylowtemp < 1 then gosub settemplimits
	if dailylowtemp > 200 or yearlylowtemp > 200 or dailyhightemp < 100 or yearlyhightemp < 100 then gosub settemplimits
return

EXHAUSTSTEPCOUNTRESET ' firelit subroutine sends us here
	'NOTE  this should be a total of 24 steps total from wide open limit
	repeatuntilLimit
	low p2   ' this determines stepper rotation
	pulsout p3,75000
	if in5 = 1 then bypassRepeat
	pause 200
	goto repeatuntillimit
	bypassRepeat
	gosub exhaustwideopen ' close damper 4 steps off from wide open limit switch
	stepcount = 82 ' stepper moves 50 steps for 90 degrees. subtract 4 steps for limit switch * 2 for display
	'exhaustwideopen has moved stepper off Limit switch 4 steps
	'stepcount = stepcount * 2 max 90 'multiply *2 for display purposes and temperature's
	for i = 1 to 20 ' run exhaust damper back from full travel now for a safe start position. at 46 degrees open
	gosub exhaustclosed
'	serout 1,i9600,[1,22,dec I] ' display count TEMPORARY FOR TEST
	pause 50
	next
	exhaustopenlimitbit = 0		' reset to 0 because we have been in the exhaustwideopen subroutine
RETURN


SETTEMPLIMITS ' eeprom values were bad, reset to base limits
	write 7,1
	write 8,150
	write 9,200
	write 10,180
	write 11,180	
	write 12,100
	write 13,100
	data 0,0,0,0,0,0,0,1,150,200,90,90,30,20,11,12,12,11,12,25,12,11,1,1
	gosub readrtcburst
	gosub tempoutdoor
	gosub updateoutsidetemp
	return 

DS1620IndoorSETUP 'setup subroutine for ds1620
	low	IndoorRST 	; Shutdown 1620
	pause 50 	; Time for reset to occur
	high IndoorRST 	; Get ready to write data
	shiftout dq,CLK,LSBPRE,[Wconf\8,CPU|Cont\8] ; Set configuration
	low IndoorRST 	; Reset 1620
	pause 50 	
	high IndoorRST 	
	shiftout dq,CLK,LSBPRE,[StartC\8] ; start conversion
	low IndoorRST 	; Reset 1620
return

DS1620OutdoorSETUP 'setup subroutine for ds1620
	low	OutdoorRST 	; Shutdown 1620
	pause 50 	; Time for reset to occur
	high OutdoorRST 	; Get ready to write data
	shiftout dq,CLK,LSBPRE,[Wconf\8,CPU|Cont\8] ; Set configuration
	low OutdoorRST 	; Reset 1620
	pause 50 	
	high OutdoorRST 	
	shiftout dq,CLK,LSBPRE,[StartC\8] ; start conversion
	low OutdoorRST 	; Reset 1620
return


'---------------UNUSED SUBROUTINES-------------------------

'PROGRAMCLOCKTIME 'ONLY NEEDED ONCE 
	'program ds1302 clock time below once only needed!
'	temp =$10
'	RTCCmd = ctrlreg
'	gosub writertc

'	temp = $06   '06  YEAR 2006
'	rtccmd = yrreg
'	gosub writertc

'	temp = $11    '11 NOVEMBER
'	rtccmd = Monreg
'	gosub writertc

'	temp = $13   ' 13TH DAY
'	rtccmd = datereg
'	gosub writertc

'	temp = $02  ' HOURS 
'	rtccmd = hrsreg
'	gosub writertc

'	temp = $55  ' MINUTES
'	rtccmd = minreg
'	gosub writertc

'	temp = $00
'	rtccmd = secreg
'	gosub writertc
	
'	temp=dir1
'	rtccmd = tric
'	gosub trick

'	temp = $80
'	rtccmd = ctrlreg
'	gosub writertc
'RETURN

'ReadRTCCram
'	high rtcreset
'	shiftout dq,clk,lsbfirst,[%1\1,rtccmd\6,%11\2]
'	shiftin dq,clk,lsbpre,[temp]
'	low rtcreset
'return

'WriteRTCRAM 'write to ds1602 rtc
'	high rtcreset
'	shiftout dq,clk,lsbfirst,[%0\1,rtccmd\5,%11\2,temp]
'	low rtcreset
'return

'FASTRISING ' temp is climbing fast reduce temp 3 steps at a time
'	for i = 1 to 2
'	gosub exhaustclosed
'	next
'return

'COOLINGFAST ' temp is falling to faST OPEN damper more steps each time.
'	for i = 1 to 2
'	gosub exhaustopen
'	next
'return

'COMBUSTIONOPENLIMIT ' on 2nd line
'serout 1,n9600,[init,clr]
'pause 1
'low p6
'serout 1,n9600,[init,L2]
'serout 1,n9600,["Open COMBUST     "]
'low p6   ' this determines stepper rotation
'low p14
'pulsout p7,75000
'pulsout p14,75000
'if in5 = 1 then gosub exhaustwideopen
'pause 200
'return


'COMBUSTIONCLOSEDLIMIT ' on 2nd line
'serout 1,n9600,[init,clr]
'pause 1
'high p6
'serout 1,n9600,[init,L2]
'serout 1,n9600,["CLOSE COMBUST     "]
'high p6   ' this determines stepper rotation
'low p14
'pulsout p7,75000
'pulsout p14,75000
'if in5 = 1 then gosub exhaustwideopen
'pause 200
'return



'HIGHSOUND
'SOUND P14,[1000 \ 8500]
'SOUNDBIT = 1
'RETURN

'LOWSOUND
'SOUND P14,[1000 \ 2500]
'SOUNDBIT = 1
'RETURN



'EXHAUSTSHUTONCE
'	for i = 1 to 5
'	gosub exhaustclosed
'	next
'return

'EXHAUSTOPENONCE
'	FOR I = 1 TO 5
'	GOSUB EXHAUSTOPEN
'	next
'return